library(mvtnorm)

chiqutest <- function(X,As) ## X hat m Spalten und n Zeilen, As: Teilmenge an interessierenden Paaren inklusive Lags
{
pdach <- apply(X,2,mean)
covxy <- cov(X[,1],X[,2])
pdach <- c(0.05,0.05)
n <- length(X[,1])
m <- length(X[1,])
combi <- length(As[,1])
#pdach <- rep(0.5,m)
vector <- rep(0,combi)
for(k in 1:combi)
{
i <- As[k,1]
j <- As[k,2]
l <- As[k,3]
partone <- X[1:(n-l),i] - pdach[i]
parttwo <- X[(l+1):n,j] - pdach[j]
vector[k] <- sum(partone*parttwo) / sqrt(n)
}
#return(vector)
covmatrix <- matrix(0,ncol=combi,nrow=combi)
for(a in 1:combi)
{
for(b in a:combi)
{
ia <- As[a,1]
ja <- As[a,2]
la <- As[a,3]
ib <- As[b,1]
jb <- As[b,2]
lb <- As[b,3]
l <- max(la,lb)
partone <- X[1:(n-la),ia] - pdach[ia]
parttwo <- X[(1+la):n,ja] - pdach[ja]
partthree <- X[1:(n-lb),ib] - pdach[ib]
partfour <- X[(1+lb):n,jb] - pdach[jb]
partone <- partone[1:(length(partone)-(l-la))]
parttwo <- parttwo[1:(length(parttwo)-(l-la))]
partthree <- partthree[1:(length(partthree)-(l-lb))]
partfour <- partfour[1:(length(partfour)-(l-lb))]
covmatrix[a,b] <- covmatrix[b,a] <-  
sum(partone*parttwo*partthree*partfour) - sum(partone*parttwo) * 1/n * sum(partthree*partfour)
}
}
covmatrix1 <- pdach[1]^2-2*pdach[1]^3+pdach[1]^4
covmatrix12 <- covxy^2
covmatrix2 <- pdach[2]^2-2*pdach[2]^3+pdach[2]^4
covmatrix <- matrix(c(covmatrix1,covmatrix12,covmatrix12,covmatrix2),ncol=2)
teststatistic <- t(vector) %*% solve(covmatrix) %*% vector
#pwert <- 1-pchisq(teststatistic,combi)
#return(pwert)
return(teststatistic)
}

## Simulationen

set.seed(20072014)
m <- 1000
nn <- c(250,500,1000,2000)
d <- 2
p <- 0.08
deltad <- seq(0,0.5,by=0.1)
alpha <- 0.05
rho1 <- 0
sigma1 <- matrix(rho1,ncol=d,nrow=d)
diag(sigma1) <- rep(1,d)
rho2 <- 0
sigma2 <- matrix(rho2,ncol=d,nrow=d)
diag(sigma2) <- rep(1,d)
#As=rbind(c(1,2,0),c(1,3,0),c(1,4,0),c(1,5,0),c(2,3,0),c(2,4,0),c(2,5,0),c(3,4,0),c(3,5,0),c(4,5,0))
#As=rbind(c(1,2,0),c(2,3,0),c(1,3,0))
As <- rbind(c(1,1,1),c(2,2,1))
#As <- matrix(c(1,2,0),ncol=3)
rhoar <- 0
counter <- matrix(0,ncol=length(deltad),nrow=length(nn))
for(f in 1:length(nn))
{
n <- nn[f]
for(g in 1:length(deltad))
{
print(counter)
delta <- deltad[g]*p
zaehler <- rep(0,m)
for(i in 1:m)
{
set.seed(i)
print(mean(zaehler[1:i]))
x1 <- matrix(0,ncol=d,nrow=n/2+1)
x1 <- t(apply(x1,1,function(y) rmvnorm(1,rep(0,d),sigma1)))
x2 <- matrix(0,ncol=d,nrow=n/2)
x2 <- t(apply(x2,1,function(y) rmvnorm(1,rep(0,d),sigma2)))
x <- rbind(x1,x2)
x <- apply(x,2,function(x) filter(x,c(1,rhoar),"convolution"))
x <- x[-(n+1),]
x[1:(n/4),] <- x[1:(n/4),] < qnorm(p-2*delta)*sqrt(1+rhoar^2)
x[(n/4+1):(n/2),] <- x[(n/4+1):(n/2),] < qnorm(p+delta)*sqrt(1+rhoar^2)
x[(n/2+1):(3/4*n),] <- x[(n/2+1):(3/4*n),] < qnorm(p-delta)*sqrt(1+rhoar^2)
x[(3/4*n+1):n,] <- x[(3/4*n+1):n,] < qnorm(p+2*delta)*sqrt(1+rhoar^2)
teststatistic <- chiqutest(x,As)
zaehler[i] <- teststatistic > qchisq(0.95,2)
}
counter[f,g] <- mean(zaehler)
}
}
write.table(counter,"Table 2 Instationarity with Chi2.txt")